package sun.java2d.loops;

import sun.java2d.pipe.SpanIterator;
import java.awt.image.ColorModel;
import java.awt.image.WritableRaster;
import sun.awt.image.IntegerComponentRaster;
import sun.java2d.pipe.Region;
import java.awt.Composite;
import sun.java2d.SurfaceData;

class XorCopyArgbToAny extends Blit
{
    XorCopyArgbToAny() {
        super(SurfaceType.IntArgb, CompositeType.Xor, SurfaceType.Any);
    }
    
    @Override
    public void Blit(SurfaceData surfaceData, SurfaceData surfaceData2, Composite composite, Region region, int n, int n2, int n3, int n4, int n5, int n6) {
        IntegerComponentRaster integerComponentRaster = (IntegerComponentRaster)surfaceData.getRaster(n, n2, n5, n6);
        int[] dataStorage = integerComponentRaster.getDataStorage();
        WritableRaster writableRaster = (WritableRaster)surfaceData2.getRaster(n3, n4, n5, n6);
        ColorModel colorModel = surfaceData2.getColorModel();
        SpanIterator spanIterator = CustomComponent.getRegionOfInterest(surfaceData, surfaceData2, region, n, n2, n3, n4, n5, n6).getSpanIterator();
        Object dataElements = colorModel.getDataElements(((XORComposite)composite).getXorColor().getRGB(), null);
        Object dataElements2 = null;
        Object dataElements3 = null;
        int scanlineStride = integerComponentRaster.getScanlineStride();
        n -= n3;
        n2 -= n4;
        int[] array = new int[4];
        while (spanIterator.nextSpan(array)) {
            for (int n7 = integerComponentRaster.getDataOffset(0) + (n2 + array[1]) * scanlineStride + (n + array[0]), i = array[1]; i < array[3]; n7 += scanlineStride, ++i) {
                for (int j = array[0]; j < array[2]; ++j) {
                    dataElements2 = colorModel.getDataElements(dataStorage[n7++], dataElements2);
                    dataElements3 = writableRaster.getDataElements(j, i, dataElements3);
                    switch (colorModel.getTransferType()) {
                        case 0: {
                            byte[] array2 = (byte[])(byte[])dataElements2;
                            byte[] array3 = (byte[])(byte[])dataElements3;
                            byte[] array4 = (byte[])(byte[])dataElements;
                            for (int k = 0; k < array3.length; ++k) {
                                int n8 = k;
                                array3[n8] ^= (array2[k] ^ array4[k]);
                            }
                            break;
                        }
                        case 1:
                        case 2: {
                            short[] array5 = (short[])(short[])dataElements2;
                            short[] array6 = (short[])(short[])dataElements3;
                            short[] array7 = (short[])(short[])dataElements;
                            for (int l = 0; l < array6.length; ++l) {
                                int n9 = l;
                                array6[n9] ^= (array5[l] ^ array7[l]);
                            }
                            break;
                        }
                        case 3: {
                            int[] array8 = (int[])(int[])dataElements2;
                            int[] array9 = (int[])(int[])dataElements3;
                            int[] array10 = (int[])(int[])dataElements;
                            for (int n10 = 0; n10 < array9.length; ++n10) {
                                int n11 = n10;
                                array9[n11] ^= (array8[n10] ^ array10[n10]);
                            }
                            break;
                        }
                        case 4: {
                            float[] array11 = (float[])(float[])dataElements2;
                            float[] array12 = (float[])(float[])dataElements3;
                            float[] array13 = (float[])(float[])dataElements;
                            for (int n12 = 0; n12 < array12.length; ++n12) {
                                array12[n12] = Float.intBitsToFloat(Float.floatToIntBits(array12[n12]) ^ Float.floatToIntBits(array11[n12]) ^ Float.floatToIntBits(array13[n12]));
                            }
                            break;
                        }
                        case 5: {
                            double[] array14 = (double[])(double[])dataElements2;
                            double[] array15 = (double[])(double[])dataElements3;
                            double[] array16 = (double[])(double[])dataElements;
                            for (int n13 = 0; n13 < array15.length; ++n13) {
                                array15[n13] = Double.longBitsToDouble(Double.doubleToLongBits(array15[n13]) ^ Double.doubleToLongBits(array14[n13]) ^ Double.doubleToLongBits(array16[n13]));
                            }
                            break;
                        }
                        default: {
                            throw new InternalError("Unsupported XOR pixel type");
                        }
                    }
                    writableRaster.setDataElements(j, i, dataElements3);
                }
            }
        }
    }
}
